Package org.apache.commons.beanutils

## Interface DynaBean

All Known Implementing Classes:
  `BasicDynaBean`, `ConvertingWrapDynaBean`, `LazyDynaBean`, `LazyDynaMap`, `ResultSetIterator`, `WrapDynaBean`

    public interface DynaBean

A DynaBean is a Java object that supports properties whose names and data types, as well as values, may be dynamically modified. To the maximum degree feasible, other components of the BeanUtils package will recognize such beans and treat them as standard JavaBeans for the purpose of retrieving and setting property values.

Version:
  $Id$

### Method Summary

All Methods Instance Methods Abstract Methods
`boolean` `contains​(java.lang.String name, java.lang.String key)` Does the specified mapped property contain a value for the specified key value?
`java.lang.Object` `get​(java.lang.String name)` Return the value of a simple property with the specified name.
`java.lang.Object` `get​(java.lang.String name, int index)` Return the value of an indexed property with the specified name.
`java.lang.Object` `get​(java.lang.String name, java.lang.String key)` Return the value of a mapped property with the specified name, or `null` if there is no value for the specified key.
`DynaClass` `getDynaClass()` Return the `DynaClass` instance that describes the set of properties available for this DynaBean.
`void` `remove​(java.lang.String name, java.lang.String key)` Remove any existing value for the specified key on the specified mapped property.
`void` `set​(java.lang.String name, int index, java.lang.Object value)` Set the value of an indexed property with the specified name.
`void` `set​(java.lang.String name, java.lang.Object value)` Set the value of a simple property with the specified name.
`void` `set​(java.lang.String name, java.lang.String key, java.lang.Object value)` Set the value of a mapped property with the specified name.

### Method Detail

#### contains

    boolean contains​(java.lang.String name,
                     java.lang.String key)

Does the specified mapped property contain a value for the specified key value?

Parameters:
  `name` - Name of the property to check
  `key` - Name of the key to check
Returns:
  `true`if the mapped property contains a value for the specified key, otherwise `false```
Throws:
  `java.lang.IllegalArgumentException` - if there is no property of the specified name

#### get

    java.lang.Object get​(java.lang.String name)

Return the value of a simple property with the specified name.

Parameters:
  `name` - Name of the property whose value is to be retrieved
Returns:
  The property's value
Throws:
  `java.lang.IllegalArgumentException` - if there is no property of the specified name

#### get

    java.lang.Object get​(java.lang.String name,
                         int index)

Return the value of an indexed property with the specified name.

Parameters:
  `name` - Name of the property whose value is to be retrieved
  `index` - Index of the value to be retrieved
Returns:
  The indexed property's value
Throws:
  `java.lang.IllegalArgumentException` - if there is no property of the specified name
  `java.lang.IllegalArgumentException` - if the specified property exists, but is not indexed
  `java.lang.IndexOutOfBoundsException` - if the specified index is outside the range of the underlying property
  `java.lang.NullPointerException` - if no array or List has been initialized for this property

#### get

    java.lang.Object get​(java.lang.String name,
                         java.lang.String key)

Return the value of a mapped property with the specified name, or `null` if there is no value for the specified key.

Parameters:
  `name` - Name of the property whose value is to be retrieved
  `key` - Key of the value to be retrieved
Returns:
  The mapped property's value
Throws:
  `java.lang.IllegalArgumentException` - if there is no property of the specified name
  `java.lang.IllegalArgumentException` - if the specified property exists, but is not mapped

#### getDynaClass

    DynaClass getDynaClass()

Return the `DynaClass` instance that describes the set of properties available for this DynaBean.

Returns:
  The associated DynaClass

#### remove

    void remove​(java.lang.String name,
                java.lang.String key)

Remove any existing value for the specified key on the specified mapped property.

Parameters:
  `name` - Name of the property for which a value is to be removed
  `key` - Key of the value to be removed
Throws:
  `java.lang.IllegalArgumentException` - if there is no property of the specified name

#### set

    void set​(java.lang.String name,
             java.lang.Object value)

Set the value of a simple property with the specified name.

Parameters:
  `name` - Name of the property whose value is to be set
  `value` - Value to which this property is to be set
Throws:
  `ConversionException` - if the specified value cannot be converted to the type required for this property
  `java.lang.IllegalArgumentException` - if there is no property of the specified name
  `java.lang.NullPointerException` - if an attempt is made to set a primitive property to null

#### set

    void set​(java.lang.String name,
             int index,
             java.lang.Object value)

Set the value of an indexed property with the specified name.

Parameters:
  `name` - Name of the property whose value is to be set
  `index` - Index of the property to be set
  `value` - Value to which this property is to be set
Throws:
  `ConversionException` - if the specified value cannot be converted to the type required for this property
  `java.lang.IllegalArgumentException` - if there is no property of the specified name
  `java.lang.IllegalArgumentException` - if the specified property exists, but is not indexed
  `java.lang.IndexOutOfBoundsException` - if the specified index is outside the range of the underlying property

#### set

    void set​(java.lang.String name,
             java.lang.String key,
             java.lang.Object value)

Set the value of a mapped property with the specified name.

Parameters:
  `name` - Name of the property whose value is to be set
  `key` - Key of the property to be set
  `value` - Value to which this property is to be set
Throws:
  `ConversionException` - if the specified value cannot be converted to the type required for this property
  `java.lang.IllegalArgumentException` - if there is no property of the specified name
  `java.lang.IllegalArgumentException` - if the specified property exists, but is not mapped